import { DefaultApiUtils, InitialStateApiUtils, PostApiUtils, TweetApiUtils, UserApiUtils, UserListApiUtils, V11GetApiUtils, V11PostApiUtils, V20GetApiUtils } from './apis';
import { DefaultFlag, initOverrides } from './models';
import * as i from 'twitter-gengar-generated';
import { UsersApiUtils } from './apis/usersApi';
export declare class TwitterOpenApi {
    static hash: string;
    static url: string;
    static header: string;
    static twitter: string;
    static bearer: string;
    get_browser_headers(): Promise<{
        [key: string]: string;
    }>;
    get_api_key(): Promise<{
        [key: string]: string;
    }>;
    static fetchApi: i.FetchAPI;
    initOverrides: initOverrides;
    setInitOverrides(initOverrides: initOverrides): void;
    cookie_normalize(cookie: string[]): {
        [key: string]: string;
    };
    cookieEncode(cookie: {
        [key: string]: string;
    }): string;
    setCookies(context: i.RequestContext, cookies: {
        [key: string]: string;
    }): i.RequestContext;
    getGuestClient(): Promise<TwitterOpenApiClient>;
    getClientFromCookies(cookies: {
        [key: string]: string;
    }): Promise<TwitterOpenApiClient>;
    getClient(api: i.Configuration): Promise<TwitterOpenApiClient>;
}
export declare class TwitterOpenApiClient {
    config: i.Configuration;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(config: i.Configuration, flag: DefaultFlag, initOverrides: initOverrides);
    getDefaultApi(): DefaultApiUtils;
    getTweetApi(): TweetApiUtils;
    getUserApi(): UserApiUtils;
    getUsersApi(): UsersApiUtils;
    getUserListApi(): UserListApiUtils;
    getPostApi(): PostApiUtils;
    getV11GetApi(): V11GetApiUtils;
    getV11PostApi(): V11PostApiUtils;
    getV20GetApi(): V20GetApiUtils;
    getInitialStateApi(): InitialStateApiUtils;
}
//# sourceMappingURL=api.d.ts.map