"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostApiUtils = void 0;
var utils_1 = require("../utils");
var i = require("twitter-gengar-generated");
var PostApiUtils = /** @class */ (function () {
    function PostApiUtils(api, flag, initOverrides) {
        this.api = api;
        this.flag = flag;
        this.initOverrides = initOverrides;
    }
    PostApiUtils.prototype.postCreateTweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, features, variables, response, _a;
            var _b;
            var _c, _d;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        args = __assign({ tweetText: param.tweetText }, param.extraParam);
                        queryId = 'CreateTweet';
                        features = i.PostCreateTweetRequestFeaturesFromJSON(this.flag[queryId]['features']);
                        variables = i.PostCreateTweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        variables.media.mediaEntities =
                            (_d = (_c = param.mediaIds) === null || _c === void 0 ? void 0 : _c.map(function (mediaId) { return ({
                                mediaId: mediaId,
                                taggedUsers: [],
                            }); })) !== null && _d !== void 0 ? _d : [];
                        if (param.inReplyToTweetId) {
                            variables.reply = {
                                excludeReplyUserIds: [],
                                inReplyToTweetId: param.inReplyToTweetId,
                            };
                        }
                        return [4 /*yield*/, this.api.postCreateTweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postCreateTweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    features: features,
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _e.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_e.sent()]),
                            _b)];
                }
            });
        });
    };
    PostApiUtils.prototype.postDeleteTweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, variables, response, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        args = __assign({ tweetId: param.tweetId }, param.extraParam);
                        queryId = 'DeleteTweet';
                        variables = i.PostCreateRetweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        return [4 /*yield*/, this.api.postDeleteTweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postDeleteTweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _c.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_c.sent()]),
                            _b)];
                }
            });
        });
    };
    PostApiUtils.prototype.postCreateRetweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, variables, response, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        args = __assign({ tweetId: param.tweetId }, param.extraParam);
                        queryId = 'CreateRetweet';
                        variables = i.PostCreateRetweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        return [4 /*yield*/, this.api.postCreateRetweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postCreateRetweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _c.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_c.sent()]),
                            _b)];
                }
            });
        });
    };
    PostApiUtils.prototype.postDeleteRetweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, variables, response, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        args = __assign({ sourceTweetId: param.sourceTweetId }, param.extraParam);
                        queryId = 'DeleteRetweet';
                        variables = i.PostDeleteRetweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        return [4 /*yield*/, this.api.postDeleteRetweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postDeleteRetweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _c.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_c.sent()]),
                            _b)];
                }
            });
        });
    };
    PostApiUtils.prototype.postFavoriteTweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, variables, response, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        args = __assign({ tweetId: param.tweetId }, param.extraParam);
                        queryId = 'FavoriteTweet';
                        variables = i.PostCreateRetweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        return [4 /*yield*/, this.api.postFavoriteTweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postFavoriteTweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _c.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_c.sent()]),
                            _b)];
                }
            });
        });
    };
    PostApiUtils.prototype.postUnfavoriteTweet = function (param) {
        return __awaiter(this, void 0, void 0, function () {
            var args, queryId, variables, response, _a;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        args = __assign({ tweetId: param.tweetId }, param.extraParam);
                        queryId = 'UnfavoriteTweet';
                        variables = i.PostCreateRetweetRequestVariablesFromJSON(this.flag[queryId]['variables']);
                        return [4 /*yield*/, this.api.postUnfavoriteTweetRaw({
                                pathQueryId: this.flag[queryId]['queryId'],
                                postUnfavoriteTweetRequest: {
                                    queryId: this.flag[queryId]['queryId'],
                                    variables: __assign(__assign({}, variables), args),
                                },
                            })];
                    case 1:
                        response = _c.sent();
                        _b = {
                            raw: { response: response.raw },
                            header: (0, utils_1.buildHeader)(response.raw.headers)
                        };
                        _a = utils_1.errorCheck;
                        return [4 /*yield*/, response.value()];
                    case 2: return [2 /*return*/, (_b.data = _a.apply(void 0, [_c.sent()]),
                            _b)];
                }
            });
        });
    };
    return PostApiUtils;
}());
exports.PostApiUtils = PostApiUtils;
//# sourceMappingURL=postApi.js.map