import { DefaultFlag, RequestParam, TimelineApiUtilsResponse, TweetApiUtilsData, TwitterApiUtilsResponse, initOverrides } from '../models';
import * as i from 'twitter-gengar-generated';
type GetTweetDetailParam = {
    focalTweetId: string;
    cursor?: string;
    controllerData?: string;
    extraParam?: {
        [key: string]: any;
    };
};
type GetSearchTimelineParam = {
    rawQuery: string;
    product?: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetHomeTimelineParam = {
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetHomeLatestTimelineParam = {
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetListLatestTweetsTimelineParam = {
    listId: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetUserTweetsParam = {
    userId: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetUserTweetsAndRepliesParam = {
    userId: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetUserMediaParam = {
    userId: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetLikesParam = {
    userId: string;
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type GetBookmarksParam = {
    cursor?: string;
    count?: number;
    extraParam?: {
        [key: string]: any;
    };
};
type ResponseType = TwitterApiUtilsResponse<TimelineApiUtilsResponse<TweetApiUtilsData>>;
export declare class TweetApiUtils {
    api: i.TweetApi;
    flag: DefaultFlag;
    initOverrides: initOverrides;
    constructor(api: i.TweetApi, flag: DefaultFlag, initOverrides: initOverrides);
    request<T>(param: RequestParam<i.InstructionUnion[], T>): Promise<ResponseType>;
    getTweetDetail(param: GetTweetDetailParam): Promise<ResponseType>;
    getSearchTimeline(param: GetSearchTimelineParam): Promise<ResponseType>;
    getHomeTimeline(param?: GetHomeTimelineParam): Promise<ResponseType>;
    getHomeLatestTimeline(param?: GetHomeLatestTimelineParam): Promise<ResponseType>;
    getListLatestTweetsTimeline(param: GetListLatestTweetsTimelineParam): Promise<ResponseType>;
    getUserTweets(param: GetUserTweetsParam): Promise<ResponseType>;
    getUserTweetsAndReplies(param: GetUserTweetsAndRepliesParam): Promise<ResponseType>;
    getUserMedia(param: GetUserMediaParam): Promise<ResponseType>;
    getLikes(param: GetLikesParam): Promise<ResponseType>;
    getBookmarks(param?: GetBookmarksParam): Promise<ResponseType>;
}
export {};
//# sourceMappingURL=tweetApi.d.ts.map